<?php
/*
Plugin Name: AskApache Password Protect
Plugin URI: http://www.askapache.com/wordpress/htaccess-password-protect.html
Description: Super Secure Password Protection and Security for your blog. <a href="options-general.php?page=askapache-password-protect.php">Options configuration panel</a>
Version: 3.5.1
Author: AskApache
Author URI: http://www.askapache.com
*/


/*
== Installation ==

1. Extract zip so- wp-content/plugins/askapache-password-protect/askapache-password-protect.php
2. Activate the Plugin.
3. Setup plugin options
*/



/*
/--------------------------------------------------------------------\
|                                                                    |
| License: GPL                                                       |
|                                                                    |
| AskApache Password Protect Plugin - Adds HTTP Basic Authentication |
| Copyright (C) 2008, AskApache, www.askapache.com                   |
| All rights reserved.                                               |
|                                                                    |
| This program is free software; you can redistribute it and/or      |
| modify it under the terms of the GNU General Public License        |
| as published by the Free Software Foundation; either version 2     |
| of the License, or (at your option) any later version.             |
|                                                                    |
| This program is distributed in the hope that it will be useful,    |
| but WITHOUT ANY WARRANTY; without even the implied warranty of     |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
| GNU General Public License for more details.                       |
|                                                                    |
| You should have received a copy of the GNU General Public License  |
| along with this program; if not, write to the                      |
| Free Software Foundation, Inc.                                     |
| 51 Franklin Street, Fifth Floor                                    |
| Boston, MA  02110-1301, USA                                        |
|                                                                    |
\--------------------------------------------------------------------/
*/
?>
<?php
#error_reporting( E_USER_ERROR | E_USER_WARNING | E_USER_NOTICE );

// aa_pp_options_setup
function aa_pp_options_setup() {
	add_options_page('AskApache Password Protection', 'AA PassPro', 8, basename(__FILE__), 'aa_pp_main_page');
}


function aa_pp_get_post_values(){
	global $aa_PP;
	$aa_PP=get_option('askapache_password_protect');

	if(isset($_POST['htaccessrealm']) && $_POST['htaccessrealm']!=$aa_PP['realm']){
		$aa_PP['realm']=$_POST['htaccessrealm'];
		if(strlen($aa_PP['realm'])>10)$aa_PP['realm']=substr($aa_PP['realm'], 0, 10);
		$aa_PP['change_htaccess']='1';
	}
			
	if(isset($_POST['htaccessuser']) && $_POST['htaccessuser']!=$aa_PP['user']){
		$aa_PP['user']=$_POST['htaccessuser'];
		$aa_PP['change_htpasswd']='1';
	}
			
	if(isset($_POST['htaccesspass'])||isset($_POST['modifyuser'])) {
		$aa_PP['change_htpasswd']='1';
		$aa_PP['change_htaccess']='1';
	}

	if(isset($_POST['htpasswdfile']) && $_POST['htpasswdfile']!=$aa_PP['htpasswd']) {
		if(is_writable(dirname($_POST['htpasswdfile'])) && touch($_POST['htpasswdfile'])){
			$aa_PP['htpasswd']=$_POST['htpasswdfile'];
			$aa_PP['change_htpasswd']='1';
		} else trigger_error($_POST['htpasswdfile'].' location is not writable!',E_USER_ERROR);
	}

			
	if(isset($_POST['aapassformat1']) && $_POST['aapassformat1']!=$aa_PP['format']){
		$aa_PP['format']=$_POST['aapassformat1'];
		$aa_PP['change_htpasswd']='1';
	}

	if(isset($_POST['aapassformat']) && $_POST['aapassformat']!=$aa_PP['format']){
		$aa_PP['format']=$_POST['aapassformat'];
		$aa_PP['change_htpasswd']='1';
	}
	

	update_option('askapache_password_protect',$aa_PP);
}


// aa_pp_admin_header
function aa_pp_admin_header(){
	global $aa_PP;

	if (function_exists('current_user_can')&&!current_user_can(8)||!current_user_can('upload_files')) wp_die(__("You are not allowed to be here"));
	$aa_PP=get_option('askapache_password_protect');

	$aa_PP['htaccessusers']=aa_pp_current_users($aa_PP['htpasswd'],'AskApache PassPro');
	

	if($_SERVER['REQUEST_METHOD']==='POST') 
	{
		check_admin_referer('askapache-password-protect-update_modify');
	
	
		/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
		if($aa_PP['config_step']=='2'){
			aa_pp_get_post_values();
			@ aa_pp_unlink($aa_PP['htpasswd']);
			@ aa_pp_unlink($aa_PP['admin_htaccess']);

			$aa_PP['admin_htaccess_rules']=array('AuthName "'.$aa_PP['realm'].'"',"AuthUserFile ".$aa_PP['htpasswd'],"AuthType Basic","Order Deny,Allow","Deny from all","Require valid-user","Satisfy Any",
				'<FilesMatch "\.(ico|pdf|flv|jpg|jpeg|png|gif|swf|css|js)$">','Allow from all','</FilesMatch>');
			if(!insert_with_markers($aa_PP['admin_htaccess'], 'AskApache PassPro', $aa_PP['admin_htaccess_rules']))	trigger_error("Couldnt create wp-admin/.htaccess file!",E_USER_ERROR);
		
			$aa_PP['htpasswd_rules']=array(aa_pp_hashit($aa_PP['format'],$aa_PP['user'],$_POST['htaccesspass']));	
			if(!insert_with_markers($aa_PP['htpasswd'],'AskApache PassPro',$aa_PP['htpasswd_rules'])) trigger_error('Error Creating '.$aa_PP['htpasswd'].'',E_USER_ERROR);
		
			$aa_PP['config_step']='3';

			update_option('askapache_password_protect',$aa_PP);
		}
		/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


		/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
		if($aa_PP['config_step']=='3' || $aa_PP['config_step']=='4'){		
			aa_pp_get_post_values();
			
			
			if(isset($_POST['togglewpincludes'])) {
				@ aa_pp_unlink($aa_PP['wpincludes_htaccess']);
				$aa_PP['wpincludes_htaccess_rules']=array('<IfModule mod_rewrite.c>','RewriteEngine On','RewriteBase /','RewriteCond %{THE_REQUEST} ^.*/wp-includes/.*$ [NC]','RewriteCond %{REQUEST_FILENAME} ^.+\.php$','RewriteRule .* - [F]','</IfModule>');

				if(!insert_with_markers($aa_PP['wpincludes_htaccess'], 'AskApache PassPro', $aa_PP['wpincludes_htaccess_rules']))trigger_error("Couldnt create ".$aa_PP['wpincludes_htaccess']." file!",E_USER_ERROR);
			} else @ aa_pp_unlink($aa_PP['wpincludes_htaccess']);
			
			if(isset($_POST['togglewpcontent'])) {
				@ aa_pp_unlink($aa_PP['wpcontent_htaccess']);
				$aa_PP['wpcontent_htaccess_rules']=array('<IfModule mod_rewrite.c>','RewriteEngine On','RewriteBase /','RewriteCond %{THE_REQUEST} ^.*/wp-content/.*$ [NC]','RewriteCond %{REQUEST_FILENAME} ^.+\.php$','RewriteRule .* - [F]','</IfModule>');

				if(!insert_with_markers($aa_PP['wpcontent_htaccess'], 'AskApache PassPro', $aa_PP['wpcontent_htaccess_rules']))trigger_error("Couldnt create ".$aa_PP['wpcontent_htaccess']." file!",E_USER_ERROR);
			} else @ aa_pp_unlink($aa_PP['wpcontent_htaccess']);
			
			if(isset($_POST['togglewpadmin'])) {
				@ aa_pp_unlink($aa_PP['admin_htaccess']);
				$aa_PP['admin_htaccess_rules']=array('AuthName "'.$aa_PP['realm'].'"',"AuthUserFile ".$aa_PP['htpasswd'],"AuthType Basic","Order Deny,Allow","Deny from all","Require valid-user","Satisfy Any",
					'<FilesMatch "\.(ico|pdf|flv|jpg|jpeg|png|gif|swf|css|js)$">','Allow from all','</FilesMatch>');

				if(!insert_with_markers($aa_PP['admin_htaccess'], 'AskApache PassPro', $aa_PP['admin_htaccess_rules']))	trigger_error("Couldnt create ".$aa_PP['admin_htaccess']." file!",E_USER_ERROR);
				else $aa_PP['change_htaccess']='0';
			} else {
				@ aa_pp_unlink($aa_PP['admin_htaccess']);
				$aa_PP['change_htaccess']='0';
			}
			
				
			if($aa_PP['change_htaccess']=='1'){
				@ aa_pp_unlink($aa_PP['admin_htaccess']);
				$aa_PP['admin_htaccess_rules']=array('AuthName "'.$aa_PP['realm'].'"',"AuthUserFile ".$aa_PP['htpasswd'],"AuthType Basic","Order Deny,Allow","Deny from all","Require valid-user","Satisfy Any",
					'<FilesMatch "\.(ico|pdf|flv|jpg|jpeg|png|gif|swf|css|js)$">','Allow from all','</FilesMatch>');

				if(!insert_with_markers($aa_PP['admin_htaccess'], 'AskApache PassPro', $aa_PP['admin_htaccess_rules']))	trigger_error("Couldnt create ".$aa_PP['admin_htaccess']." file!",E_USER_ERROR);
				else $aa_PP['change_htaccess']='0';
			}
		
			if($aa_PP['change_htpasswd']=='1' && strlen($_POST['htaccesspass'])>1){
				@ aa_pp_unlink($aa_PP['htpasswd']);
				$aa_PP['htpasswd_rules']=array(aa_pp_hashit($aa_PP['format'],$aa_PP['user'],$_POST['htaccesspass']));
				
				if(!insert_with_markers($aa_PP['htpasswd'],'AskApache PassPro',$aa_PP['htpasswd_rules'])) trigger_error('Error Creating '.$aa_PP['htpasswd'],E_USER_ERROR);
				else $aa_PP['change_htpasswd']='0';
			}
		
			$aa_PP['config_step']='4';
		
			update_option('askapache_password_protect',$aa_PP);
		}
		/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */	
	}
}




function aa_pp_show_encryptions($label,$type=0){
	global $aa_PP;
	
	if($type==0){
       ?>
        <p><label><?php _e($label); ?><br />
		<select name="aapassformat" id="aapassformat">
		<option value="SHA1"<?php if($aa_PP['format']=='SHA1')echo ' selected="selected"';elseif($aa_PP['algorithms']['SHA1']!='1')echo ' disabled="disabled"';?>>SHA1   </option>
        <option value="CRYPT"<?php if($aa_PP['format']=='CRYPT')echo ' selected="selected"';elseif($aa_PP['algorithms']['CRYPT']!='1')echo ' disabled="disabled"';?>>CRYPT - Unix Only</option>
        <option value="MD5"<?php if($aa_PP['format']=='MD5')echo ' selected="selected"';elseif($aa_PP['algorithms']['MD5']!='1')echo ' disabled="disabled"'?>>MD5 - Apache Only</option>
        <option value="PLAIN"<?php if($aa_PP['format']=='PLAIN')echo ' selected="selected"';elseif($aa_PP['algorithms']['PLAIN']!='1')echo ' disabled="disabled"'?>>PLAIN - Win/BEOS</option>
		</select>
		</label></p>
        <?php
	} elseif($type==3){
	?>
		<p><label><?php _e($label); ?><br />
        <input id="aapassformat1" name="aapassformat1" type="hidden" value="<?php echo $aa_PP['format']; ?>" /></label></p>
		<ul>
		<li><label><input class="valinp" name="aapassformat1" id="aapassformatcrypt" type="radio" value="CRYPT" <?php if($aa_PP['format']=='CRYPT')echo 'checked="checked"'; 
		elseif($aa_PP['algorithms']['CRYPT']!='1')echo 'disabled="disabled"'; ?> /> <strong>CRYPT</strong> - Unix only. Uses the traditional Unix crypt function with a randomly-generated 32-bit salt.</label></li>
		<li><label><input class="valinp" name="aapassformat1" id="aapassformatsha1" type="radio" value="SHA1" <?php if($aa_PP['format']=='SHA1')echo 'checked="checked"'; 
		elseif($aa_PP['algorithms']['SHA1']!='1')echo 'disabled="disabled"'; ?> /> <strong>SHA1</strong> - Base64-encoded SHA-1 digest of the password.</label></li>
		<li><label><input class="valinp" name="aapassformat1" id="aapassformatmd5" type="radio" value="MD5" <?php if($aa_PP['format']=='MD5')echo 'checked="checked"'; 
		elseif($aa_PP['algorithms']['MD5']!='1')echo 'disabled="disabled"'; ?> /> <strong>MD5</strong> - Apache-specific algorithm using an iterated MD5 digest of randoml 32-bit salt and the password.</label></li>
		<li><label><input class="valinp" name="aapassformat1" id="aapassformatplain" type="radio" value="PLAIN" <?php if($aa_PP['format']=='PLAIN')echo 'checked="checked"'; 
		elseif($aa_PP['algorithms']['PLAIN']!='1')echo 'disabled="disabled"'; ?> /> <strong>PLAIN TEXT</strong> (i.e. unencrypted) - Windows, BEOS, &amp; Netware only</label></li>
		</ul>
	<?php
	}
}



// aa_pp_main_page
function aa_pp_main_page() {
	global $aa_PP,$aapasspromess;
	
	if (! user_can_access_admin_page()) wp_die( __('You do not have sufficient permissions to access this page.') );
	if (function_exists('current_user_can')&&!current_user_can(8)||!current_user_can('upload_files'))wp_die(__("You are not allowed to be here"));
	?>

	
	<div class="wrap" style="min-width:600px;">
	<h2><?php echo $aa_PP['plugin_data']['Name']; ?></h2>
    <?php //echo '<pre>';print_r($aa_PP);echo '</pre>';?>
	<form action="<?php echo attribute_escape($_SERVER["REQUEST_URI"]); ?>" method="post"><?php wp_nonce_field('askapache-password-protect-update_modify'); ?>


	<?php 
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */	
	if($aa_PP['config_step']=='2'){?>
		<hr style="visibility:hidden;padding-top:.5em;clear:both;" /><div id="your-profile" style="min-width:300px;"><fieldset id="information" style="width:85%; float:none; margin:0 auto;">
		<legend>Installation</legend><hr style="visibility:hidden;padding-top:.5em;clear:both;" />
		<h3>Create User and Pass for .htpasswd</h3>
		<p><label>Pop-Up Message <em>Auth-Name / Realm</em>:<br /><input id="htaccessrealm" name="htaccessrealm" size="50" type="text" style="font-size:16px;" value="<?php echo $aa_PP['realm']; ?>" /></label></p>
		<p><label>Username:<br /><input id="htaccessuser" name="htaccessuser" size="16" type="text" style="font-size:16px;" value="<?php echo $aa_PP['user']; ?>" /></label></p>
		<p><label>Password:<br /><input id="htaccesspass" name="htaccesspass" size="16" type="text" style="font-size:16px;" value="<?php if(isset($_POST['htaccesspass'])) echo $_POST['htaccesspass'];else echo ''; ?>" /></label></p>
		<?php aa_pp_show_encryptions('.htpasswd Encryption Settings:',0); ?>
		<p><label>.htpasswd location:<br /><input id="htpasswdfile" name="htpasswdfile" size="16" type="text" style="font-size:10px;" value="<?php echo $aa_PP['htpasswd']; ?>" /></label></p>

		<p class="submit"><label><br /><input name="asdf1" id="asdf1" value="<?php _e('Add User &raquo;'); ?>" type="submit" class="button valinp" /></label></p>
        <h4>AskApache PassPro Encryption Algorithm Descriptions</h4>
		<p><strong>CRYPT</strong> - Unix only. Uses the traditional Unix crypt function with a randomly-generated 32-bit salt.</p>
		<p><strong>SHA1</strong> - Base64-encoded SHA-1 digest of the password.</p>
		<p><strong>MD5</strong> - Apache-specific algorithm using an iterated MD5 digest of randoml 32-bit salt and the password.</p>
		<p><strong>PLAIN TEXT</strong> (i.e. unencrypted) - Windows, BEOS, &amp; Netware only</p><hr style="visibility:hidden;padding-top:.25em;clear:both;" />

		<hr style="visibility:hidden;padding-top:1em;clear:both;" /></fieldset>
		</div><hr style="visibility:hidden;clear:both;" />
        
        
        
	<?php 
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */	
	} else if($aa_PP['config_step']=='3'||$aa_PP['config_step']=='4'){?>
    
		<hr style="visibility:hidden;padding-top:.5em;clear:both;" />
        
        <fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">Configurable .htaccess Security Modules</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<table class="widefat">
		<thead><tr>
		<th width="10%">Protecting</th>
		<th width="70%">Description</th>
		<th style="text-align: center">Enable</th>
		</tr></thead>
        
		<tbody id="the-list">
		<tr id="l-1" valign="middle" class="alternate">
		<td>/wp-admin/*.*<br /></td>
		<td>Requires a valid user/pass to access any non-static (css, js, images) file in this directory</td>
		<td align='center'><input type="checkbox" name="togglewpadmin" id="togglewpadmin" <?php if(is_file($aa_PP['admin_htaccess']))echo 'checked="checked" ';?> /></td>
		</tr>
        
		<tr id="l-2" valign="middle" >
		<td>/wp-content/*.php<br /></td>
		<td>Denies any Direct request for files ending in .php with a 403 Forbidden</td>
		<td align='center'><input type="checkbox" name="togglewpcontent" id="togglewpcontent" <?php if(is_file($aa_PP['wpcontent_htaccess']))echo 'checked="checked" ';?> /></td>
		</tr>
        
		<tr id="l-3" valign="middle"  class="alternate">
		<td>/wp-includes/*.php<br /></td>
		<td>Denies any Direct request for files ending in .php with a 403 Forbidden</td>
		<td align='center'><input type="checkbox" name="togglewpincludes" id="togglewpincludes" <?php if(is_file($aa_PP['wpincludes_htaccess']))echo 'checked="checked" ';?> /></td>
		</tr>
        
        
		</tbody></table>
        <p><label><br /><input name="updatemodules" id="updatemodules" value="<?php _e('Update Modules &raquo;'); ?>" type="submit" class="button valinp" /></label></p>
        </div></div></fieldset>
        
        <hr style="visibility:hidden;padding-top:.5em;clear:both;" /><div id="your-profile">
		<fieldset id="information" style="width:43%; float:left;">
		<legend>Modify .htaccess User</legend>
		<p><label>Auth Name:<br /><input id="htaccessrealm" name="htaccessrealm" size="50" type="text" style="font-size:15px;" value="<?php echo $aa_PP['realm']; ?>" /></label></p>
		<p><label>Username:<br /><input id="htaccessuser" name="htaccessuser" size="50" type="text" style="font-size:16px;" value="<?php echo $aa_PP['user']; ?>" /></label></p>
		<p><label>Password:<br /><input id="htaccesspass" name="htaccesspass" size="50" type="text" style="font-size:16px;" value="<?php if(isset($_POST['htaccesspass']))echo $_POST['htaccesspass']; ?>" /></label></p>
		<?php aa_pp_show_encryptions('.htpasswd Encryption Settings:',0); ?>
		<p><label>.htpasswd location:<br /><input id="htpasswdfile" name="htpasswdfile" size="16" type="text" style="font-size:10px;" value="<?php echo $aa_PP['htpasswd']; ?>" /></label></p>

		<p><label><br /><input name="modifyuser" id="modifyuser" value="<?php _e('Modify .htaccess User &raquo;'); ?>" type="submit" class="button valinp" /></label></p>
		<?php if($_SERVER['REQUEST_METHOD']!='GET')	{?><span style="visibility:hidden;overflow:hidden;display:block;width:1px;height:1px;background-image:url('askapache-<?php echo rand(1,1000);?>-.bmp');"></span><?php }?>
        </fieldset>
        
        
		<fieldset id="contact-info" style="width:33%; float:left;">
		<legend>Multi-Users.. Coming Soon</legend>
		<table class="widefat">
        <thead><tr>
		<th width="35%">Username</th>
		<th width="35%">Password</th>
		<th style="text-align: center">enabled</th>
		</tr></thead>
        
		<tbody id="the-list">
		<tr id="l-1" valign="middle">
		<td><?php echo $aa_PP['user']; ?><br /></td>
		<td><?php echo $aa_PP['format']; ?></td>
		<td align='center'>Yes</td>
		</tr>
        
        
		</tbody></table>
		<hr style="visibility:hidden;padding-top:.25em;clear:both;" /></fieldset><hr style="visibility:hidden;clear:both;" /></div><hr style="visibility:hidden;clear:both;" />

		<div id="advancedstuff" class="dbx-group" style="min-width:300px;">
		<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">View <?php echo basename($aa_PP['htpasswd']);?></h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<p class="desc"><?php echo $aa_PP['htpasswd']; ?></p>
		<pre style="width:80%; margin-left:2em;"><?php aa_pp_readfile($aa_PP['htpasswd']); ?></pre>
		</div></div></fieldset><hr style="visibility:hidden;clear:both;padding-top:.25em;" />

        <?php if(is_file($aa_PP['admin_htaccess'])){?>
		<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">View wp-admin .htaccess</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<p class="desc"><?php echo $aa_PP['admin_htaccess']; ?><br style="clear:both;" /></p>
		<pre style="width:80%; margin-left:2em;"><?php aa_pp_readfile($aa_PP['admin_htaccess']); ?></pre>
		</div></div></fieldset><hr style="visibility:hidden;clear:both;padding-top:.25em;" />
		<?php } ?>

        <?php if(is_file($aa_PP['wpcontent_htaccess'])){?>
		<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">View wp-content .htaccess</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<p class="desc"><?php echo $aa_PP['wpcontent_htaccess']; ?><br style="clear:both;" /></p>
		<pre style="width:80%; margin-left:2em;"><?php aa_pp_readfile($aa_PP['wpcontent_htaccess']); ?></pre>
		</div></div></fieldset><hr style="visibility:hidden;clear:both;padding-top:.25em;" />
		<?php } ?>

		<?php if(is_file($aa_PP['wpincludes_htaccess'])){?>
		<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">View wp-includes/.htaccess</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<p class="desc"><?php echo $aa_PP['wpincludes_htaccess']; ?><br style="clear:both;" /></p>
		<pre style="width:80%; margin-left:2em;"><?php aa_pp_readfile($aa_PP['wpincludes_htaccess']); ?></pre>
		</div></div></fieldset><hr style="visibility:hidden;clear:both;padding-top:.25em;" />
        <?php } ?>

		<?php /*<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">Set Default Password Encryption Algorithm</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<?php aa_pp_show_encryptions('Available Encryption Algorithms:',3); ?>
		</div></div></fieldset>*/?>
        <hr style="visibility:hidden;clear:both;padding-top:.25em;" />
        
		</div><hr style="visibility:hidden;clear:both;" />

		<?php
	}?>
    
	<hr style="visibility:hidden;clear:both;" />
	<div style="width:600px; margin:0 auto;">
    <div style="width:32%; overflow:hidden; float:left;"><h3 class="dbx-handle">About This Plugin</h3>
	<p><?php echo _e('Version:'); echo ' <strong>'.$aa_PP['plugin_data']['Version'].'</strong>'; ?></p>
	<p><?php echo _e('Info: '); echo str_replace($aa_PP['plugin_data']['Name'],'Plugin Homepage',$aa_PP['plugin_data']['Title']); ?></p>
	<p><?php _e('Author'); ?>: <?php echo $aa_PP['plugin_data']['Author']; ?></p></div>

	<div style="width:30%; overflow:hidden; float:left;"><h3 class="dbx-handle">AskApache Links</h3>
	<p>&middot; <a href="http://www.askapache.com/seo/404-google-wordpress-plugin.html">Google 401.php Plugin</a></p>
	<p>&middot; <a href="http://www.askapache.com/online-tools/htpasswd-generator/">.htpasswd Generator</a></p>
	<p>&middot; <a href="http://www.askapache.com/htaccess/apache-htaccess.html">htaccess tutorial</a></p></div>

	<div style="width:30%; overflow:hidden; float:left;"><h3 class="dbx-handle">Security Articles</h3>
	<p>&middot; <a href="http://codex.wordpress.org/Hardening_WordPress">Hardening WordPress</a></p>
	<p>&middot; <a href="http://www.askapache.com/htaccess/mod_security-htaccess-tricks.html">mod_security tricks</a></p>
	<p>&middot; <a href="http://codex.wordpress.org/Changing_File_Permissions">File Permissions</a></p></div><hr style="visibility:hidden;padding-top:.25em;clear:both;" /></div>
    </form></div><hr style="visibility:hidden;padding-top:.25em;clear:both;" />
	
	<?php	
}













// aa_pp_unlink
function aa_pp_unlink($f) {
	if (is_dir($f) && !is_link($f)) aa_pp_rm_dir($f);
	@ unlink($f);
	if(!file_exists($f))return true;
	@ chmod($f,0777);
	$stat = stat(dirname($f));
	$dir_perms = $stat['mode'] & 0007777;	
	@ chmod(dirname($f),$dir_perms);
	@ unlink($f);
	@ chmod(dirname($f),$stat['mode']);
	if(!file_exists($f))return true;
	else {
		trigger_error("Couldnt delete $f", E_USER_WARNING);
		return false;
	}
}

function aa_deltree($pre) {
 foreach(glob($pre."*",GLOB_ONLYDIR) as $dirf) {
    foreach(glob("$dirf/".'{.htaccess,.htpasswda1,401.php,test.php}', GLOB_BRACE) as $sf) {
      if (is_dir($sf) && !is_link($sf)) {
        aa_deltree($sf);
		rmdir($sf);
      } else unlink($sf);
    } 
  	rmdir($dirf);
  } 
}


function aa_pp_rm_dir($dir){
	$dir = rtrim($dir, DIRECTORY_SEPARATOR);
	$top_dir = $dir;
	$stack = array($dir);
	$index = 0;
	while ($index < count($stack)) {
		$dir = $stack[$index];
		$dh = @ opendir($dir);
		if (!$dh)return false;
		while (($file = @ readdir($dh)) !== false) {
			if ($file == '.' or $file == '..')	continue;
			if (@ is_dir($dir . DIRECTORY_SEPARATOR . $file))$stack[] = $dir . DIRECTORY_SEPARATOR . $file;
			else if (@ is_file($dir . DIRECTORY_SEPARATOR . $file))@ unlink($dir . DIRECTORY_SEPARATOR . $file);
		}
		$index++;
	}
	$stack = array_reverse($stack);
	foreach($stack as $dir) {
		if ( $dir != $top_dir)@ rmdir($dir);
	}
	@ rmdir($dir);
}





// aa_pp_mktempdir
function aa_pp_mktempdir($dirname,$prefix){
	$old=umask(0);
	$TRpdirname=tempnam(ABSPATH.'wp-content', $prefix);
	$stat = stat(ABSPATH.'wp-content');
	$dir_perms = $stat['mode'] & 0007777;
	@ chmod($TRpdirname, $dir_perms);
	aa_pp_unlink($TRpdirname);
	
	if (! mkdir($TRpdirname, 0777)) {
		trigger_error("Error creating directory $dirname with $prefix",E_USER_ERROR);
	}
	
	umask($old);
	return $TRpdirname;
}



// aa_pp_file_put_c
function aa_pp_file_put_c($filename,$content){
	if (function_exists("file_put_contents")) {	@ file_put_contents($filename, $content); return true; }
	else {
		$old=umask(0);
		$fh = @ fopen($filename, 'w+');
		if (!$fh) return false;
		@ fwrite($fh, $content);
		@ fclose($fh);
		@ touch($filename);
		@ chmod($filename, $file_perms);
		umask($old);
	}
	return true;
}

                

// aa_pp_readfile
function aa_pp_readfile($fn){
	if(file_exists($fn) && filesize($fn)>0) {
		if(!$f = @fopen($fn, 'r'))return false;
		$filecontent = fread($f, filesize($fn));
		$filecontent = htmlspecialchars($filecontent);
	}
	else $filecontent = 'file does not exist!';
	if(fclose($f))echo $filecontent;
}








// aa_pp_test_userpass
function aa_pp_test_userpass($u,$p,$path){
	$ref=get_option('siteurl');
	$timeout=10;
	$useragent='AskApache.com PassPro';
	$uri=($path!='/') ? parse_url($path) : parse_url($ref);
	$encoded=base64_encode("$u:$p");
	$host=$_SERVER['HTTP_HOST'];
	$ip=(isset($_SERVER["SERVER_ADDR"])) ? $_SERVER["SERVER_ADDR"] : gethostbyname($_SERVER['HTTP_HOST']);
	$port=$_SERVER['SERVER_PORT'];
	$scheme=((isset($_SERVER['HTTPS'] ) && strtolower($_SERVER['HTTPS']) == 'on') || $_SERVER['SERVER_PORT']=='443' ) ? 'ssl://' : '';
	$out='';
	if(!$fp = fsockopen($scheme.$ip, $port, $errno, $errstr, $timeout)) return "$scheme, $ip, $port, $errno, $errstr, $timeout";
    if(!fputs($fp, "GET $path HTTP/1.1\r\nHost: $host\r\nUser-Agent: $useragent\r\nReferer: $ref\r\nAccept: */*\r\n"."Authorization: Basic $encoded"."\r\nConnection: Close\r\n\r\n")) return false;
	else list(,$response) = explode(" ", fgets($fp, 256)); 
	if(fclose($fp))	return $response;
}



function aa_pp_current_users($HTPASS, $mark){
    $CURRENT_USERS=array();
	$cu=array();
    $cu=extract_from_markers($HTPASS, $mark);
    foreach($cu as $key){
        $CURRENT_USERS[]=preg_replace('/(.+):(.+)/', "\\1", $key, 1);
    }
	return array($CURRENT_USERS);
}


// aa_pp_hashit
function aa_pp_hashit($format,$user='',$pass=''){
	if(!function_exists('crypt') || !function_exists('sha1'))trigger_error("Error Creating .htpasswd hashes! Need crypt or sha1",E_USER_ERROR); 
	$hash='';
	switch ($format){
		case 'PLAIN':
    		$hash=$user.':'.$pass;
			break;
		case 'CRYPT':
			$seed = NULL;
    		for ($i = 0; $i < 8; $i++) {$seed .= substr('0123456789abcdef', rand(0,15), 1);}
   			$hash=$user.':'.crypt($pass, "$1$".$seed);
			break;
		case 'SHA1':
			$hash=$user.':{SHA}'.base64_encode(sha1($pass, TRUE));
			break;
		case 'MD5': // php.net/crypt.php#73619
			$saltt = substr(str_shuffle("abcdefghijklmnopqrstuvwxyz0123456789"), 0, 8);
    		$len = strlen($pass);$text = $pass.'$apr1$'.$saltt;$bin = pack("H32", md5($pass.$saltt.$pass));
    		for($i = $len; $i > 0; $i -= 16) { $text .= substr($bin, 0, min(16, $i)); }
    		for($i = $len; $i > 0; $i >>= 1) { $text .= ($i & 1) ? chr(0) : $pass{0}; }
			$bin = pack("H32", md5($text));
    		for($i=0; $i<1000; $i++) { $new = ($i & 1) ? $pass : $bin; if ($i % 3) $new .= $saltt; if ($i % 7) $new .= $pass; $new .= ($i & 1) ? $bin : $pass; $bin = pack("H32", md5($new)); }
    		for($i=0; $i<5; $i++) { $k = $i + 6; $j=$i + 12; if($j==16){ $j = 5; } $TRp = $bin[$i].$bin[$k].$bin[$j].$TRp; }
    		$TRp = chr(0).chr(0).$bin[11].$TRp;
    		$TRp = strtr(strrev(substr(base64_encode($TRp), 2)),"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
    		$hash="$user:$"."apr1"."$".$saltt."$".$TRp;
			break;
	}
	
	return $hash;
}





// aa_pp_activate
function aa_pp_activate(){
	global $userdata,$user_login,$user_login,$user_pass_md5,$user_email,$aa_PP,$aapasspromess;
	
	// delete old options
	$oldoptions=array('aa_home_folder','aa_wpadmin_folder','aa_htpasswd_file','aa_htaccess_file','aa_original_htpasswd','aa_original_htaccess','aa_plugin_message','aa_plugin_version','aa_home','aa_wpadmin',
	'aa_htpasswd_f','aa_htaccess_f','aa_user','aa_plugin_message','aa_home_folder','aa_wpadmin_folder','aa_htpasswd_file','aa_htaccess_file','aa_original_htpasswd','aa_original_htaccess','aa_plugin_message',
	'aa_plugin_version','htpasswd','config_step','htpasswd','format','user','aa_pp_docroot_htaccess','realm','aa_pp_wp_admin_htaccess',
	'aa_pp_wp_content_htaccess','aa_pp_wp_includes_htaccess','aa_pp_main_base64','config_step','aa_pp_ok','htpasswd','config_step','format','user','realm');
	foreach($oldoptions as $key){ delete_option($key); }

	get_currentuserinfo();
	$username = (isset($user_login)&&!empty($user_login)&&$user_login!='admin') ? $user_login : 'askapache';
	
	$aa_PP['user']=$username;
	$aa_PP['format']='CRYPT';
	$aa_PP['email']=$user_email;
	$aa_PP['pass']=substr(md5(uniqid(microtime())), 0, 4);
	$aa_PP['realm']='Protected By AskApache';
	$aa_PP['htaccess_support']='0';
	$aa_PP['config_step']='1';
	$aa_PP['algorithms']=array('CRYPT'=>0,'MD5'=>0,'SHA1'=>0,'PLAIN'=>0);
	$aa_PP['plugin_data']=get_plugin_data(__FILE__);
	$aa_PP['change_htpasswd']='0';
	$aa_PP['change_htaccess']='0';
	
	
	
	// create the .htaccess file
	$stat = stat(ABSPATH.'wp-content');
	$dir_perms = $stat['mode'] & 0007777;
	$file_perms = $dir_perms & 0000666;
	$aa_PP['admin_htaccess'] = ABSPATH.'wp-admin/.htaccess';
	$aa_PP['wpincludes_htaccess'] = ABSPATH.'wp-includes/.htaccess';
	$aa_PP['wpcontent_htaccess'] = ABSPATH.'wp-content/.htaccess';
	$aa_PP['htpasswd'] = ABSPATH.'wp-admin/.htpasswda1';
	@ aa_pp_unlink($aa_PP['admin_htaccess']);
	@ aa_pp_unlink($aa_PP['htpasswd']);
	
	$t='eNrj5bKxL8go4OVyyEhNTEkt0lByzs8rSc0r0Q2pLEi1UsjMTUxP1U/PTFPStMaiyCc1L70kw0rBxBIsn5qcka9QkJicraHkoaWko2RibmJpYmZsYWxpZmhgaGAAwpYgGgrSkABExMgwzdLAxMDU0ATEAaJkuGKofrC4kakJiG2cBLG2IrMESmmA+PZ2AEyvN7w=';
	$e='eNqFUU1PwkAQvTfpfxgbDnCgQ40nKIsIGEhQG60HT2RpV7bhY9fdIRV/vdtSEi/E05vMvDdvJi8eaanB99R6ZYkbancGvncvBc+FaQfzNE0wCiO460UwPpJUpvjhVKgDvIqvY2FEHnQG8EfxRpyOtv+vYMR8L76ZvkzSj2QG8/RpCcn7w3IxgaCLuJilj4jTdHqe3IY'.
	'9xNlzUGkk7Xc1OsMKqaCdYNftYjwzHBUvmrXKT/WOiF0TuZEjaJYYRSIjkcP6BDEHacTnMJBEuo9YlmXI7ZZrnkkRZmqPpTK5NsJalMSzzBVdza2t2l19XhVWHwRsbLfjWgdJQ4DGyx0SI2cx6vroy7F4+bxKzPdam6HLbCNole0EP9S5iUwqaG2q6rugBurJiP0CaXaZXQ==';
	
	$TRp=aa_pp_mktempdir(ABSPATH.'wp-content/', 'aa30tst');
	$TRpb='/'.basename($TRp).'/';
	
	$g=array(aa_pp_hashit('CRYPT','testCRYPT','testCRYPT'),aa_pp_hashit('MD5','testMD5','testMD5'),aa_pp_hashit('SHA1','testSHA1','testSHA1'),aa_pp_hashit('PLAIN','testPLAIN','testPLAIN'));
	
	$t1=gzuncompress(base64_decode($e));
	$t2=ltrim(gzuncompress(base64_decode($t)));	
	
	$htaccessrules=array("Options +All","DirectoryIndex $TRpb"."401.php 401.php","ErrorDocument 401 $TRpb"."401.php","ErrorDocument 403 $TRpb"."401.php",'AuthName "htpasstest"',
	"AuthUserFile ".ABSPATH."wp-content$TRpb".".htpasswda1","AuthType Basic","Require valid-user");
	
	if(!insert_with_markers("$TRp/.htaccess", 'Test', $htaccessrules)){
		trigger_error("Couldnt create $TRp/.htaccess file!",E_USER_NOTICE);
		$aa_PP['htaccess_support']='0';
	}
	
	if(aa_pp_file_put_c("$TRp/401.php",$t1)){ 
		trigger_error("Error Creating test pages for HTTP Authentication Enabled Test files!",E_USER_NOTICE);
		$aa_PP['htaccess_support']='0';
	}

	if(!insert_with_markers("$TRp/.htpasswda1", 'Test', $g)){ 
		trigger_error("Error Creating $TRp/.htpasswda1 Test files!",E_USER_NOTICE);
		$aa_PP['htaccess_support']='0';
	}

	if(aa_pp_file_put_c("$TRp/test.php",$t2)){ 
		trigger_error("Error Creating $TRp/test.php for HTTP Authentication Enabled Test files!",E_USER_NOTICE);
		$aa_PP['htaccess_support']='0';
	}
	
	
	foreach($aa_PP['algorithms'] as $key=>$value){
		$r=aa_pp_test_userpass("test$key","test$key","/wp-content$TRpb"."test.php");
		if($r=='200'){
			$aa_PP['algorithms'][$key]='1';
			$aa_PP['htaccess_support']='1';
		} 
		else $aa_PP['algorithms'][$key]='0';
	}

	
	$aa_PP['test_delete']=$TRp;
	$aa_PP['config_step']='2';
	
	update_option('askapache_password_protect',$aa_PP);
	sleep(2);
	aa_deltree(dirname($TRp)."/aa30tst");
}



// aa_pp_deactivate
function aa_pp_deactivate(){
	global $aa_PP;
	$aa_PP=get_option('askapache_password_protect');
	@ aa_pp_unlink($aa_PP['wpincludes_htaccess']);
	@ aa_pp_unlink($aa_PP['wpcontent_htaccess']);
	@ aa_pp_unlink($aa_PP['admin_htaccess']);
	@ aa_pp_unlink($aa_PP['htpasswd']);
	aa_deltree(dirname($aa_PP['test_delete'])."/aa30tst");
	delete_option('askapache_password_protect');
}




register_activation_hook(__FILE__, 'aa_pp_activate');
register_deactivation_hook(__FILE__, 'aa_pp_deactivate');
add_action('admin_menu', 'aa_pp_options_setup');

if( strpos($_SERVER['REQUEST_URI'], basename(__FILE__))!==false ) add_action('admin_head', 'aa_pp_admin_header');
?>